/*
HOTELPARTNER
Name:       Weslley De Souza
Date:       16.08.2017
Version:    1.0
Notes:      Entry Point

CHANGELOG:

 */

//Library's
const _HP         = require("./classHotels.js");
const _SERVER     = require("./server.js");
const parseString = require('xml2js').parseString;

//START SERVER
_SERVER.start();

//GET PARAMETERS
var currentip   = '0.0.0.0';
const hasclient = process.argv.indexOf('-client');
const hasmobile = process.argv.indexOf('-mobile');
const client    = hasclient>=0? process.argv[hasclient+1] :'WDS';
const slave     = _SERVER.os.hostname().replace('slave','');


function getNewJob()         {
    console.log("");
    console.log("GETTING NEW JOB FROM DB... CLIENT:" +client );
    let data = "";

    return new Promise(resolve=>{
            _SERVER.http.get('http://www.yieldagent.ch/relay/cityov/requestJobV8.php?version=2217&client='+client, function(res) {
                if (res.statusCode >= 200 && res.statusCode < 400)
                {
                    res.on('data', function(data_) { data += data_.toString(); });
                    res.on('end', function() {
                        parseString(data, function (err, result) {

                            if(result){
                                let ids  = [];
                                let city =result.Request.CityConfig[0].URLArguments[0];
                                city     = city.split(';city=');
                                city.shift();
                                city.forEach(t=>{
                                    t=t.substr(0,t.indexOf(';'))
                                    ids.push(t)
                                })
                                let job = {
                                    "id"      :result.Request.CityConfig[0].CityID[0],
                                    "cityid"  :ids,
                                    "name"    :result.Request.CityConfig[0].CityName[0],
                                    "dates"   :result.Request.Dates[0].Date,
                                    "job"     :result.Request.JobID[0]
                                }
                                resolve(job)
                            }

                            if(err){
                                console.log(err)
                                _SERVER.reboot();
                            }

                        });
                    });
                }
            }).on('error', function(err) {
                // Handle error
                console.log("Error while fetching new Job");
                let hosturl = 'http://192.168.56.1:88/newip?gateway='+slave+'&client='+client+'&job=-1';
                _SERVER.fetch(hosturl)
                setTimeout(()=>{
                    getNewJob();
                },30000)
            });
    })

}
function startSeleniumJOB()  {
    console.log("->Selenium Version")
        getNewJob().then(arg => {
            console.log("JOB FOUND:");
            console.log(arg);
            console.log("=====================")
            _SERVER.showExternalIP().then(ip=>{
                currentip=ip;
              let count = 0;
              /*TODO: remove timeouts*/
              arg.cityid.forEach(function (cityid, i) {
                setTimeout(function () {
                    console.log("SELENIUM IS CURRENTLY DISABLED, USE MOBILE");
                    /*
                    arg.dates.forEach(function (start, index) {
                        setTimeout(function () {
                            let room  = 1;
                            let adult = 1;
                            let child = 1;

                            const end     = _SERVER.time(start).add(1, 'day').format('YYYY-MM-DD');
                            const options =  {
                                url: 'http://' + _SERVER.config.ip + ':' + _SERVER.config.port + `/all?id=${cityid.replace('city=', '').replace('|si=ai%2Cco%2Cci%2Cre%2Cdi', '')}&place=${arg.name.replace(" ", '+')}&startdate=${start}&enddate=${end}&room=${room}&adult=${adult}&child=0&job=${arg.job}&dbid=${arg.id}`,
                                timeout: 900000
                            }

                            _SERVER.request(options, function (err, resp, body) {
                                console.log("req done "+count)
                                console.log(body);
                                count++;
                                if(count>=7){
                                    startJOB();
                                    count =0;
                                }
                            })
                        }, 55500 * index + 1);
                    })
                    */
                }, 85000 * i + 1 * arg.cityid.length)
            })
            });
      });
    }
function startMobileJob()    {
    console.log("->Mobile Version")
    let isfetching = true;
    getNewJob().then(arg => {
         if(arg.cityid[0]=='' || !arg.cityid[0])
         {
             getNewJob();
             return
         }

        console.log("JOB FOUND:");
        _SERVER.showExternalIP(false).then(ip=>{

        currentip = ip;
        console.log(arg);
        console.log("=====================")
        console.log("Current IP: " + currentip)

        let city        = arg.name.replace(" ", '+');

        let icity       =  0;
        let countcity   =  arg.cityid.length;

        let idate       =  0;
        let countdate   =  arg.dates.length;


        nextCityId();
        function nextCityId()     {
            if(icity==countcity && isfetching){
                console.log("Job Done")
                console.log(JSON.stringify(_HP.hotels.Booking))
                startMobileJob();
            }
            if(icity<countcity)
            {
                idate=0;
                nextDate(arg.cityid[icity])
                icity++;
            }

        }
        function nextDate(cityid) {
                 //Clear after new date
                 _HP.hotels.Booking = [];
                const start = arg.dates[idate];
                fetchIphoneXMLData(1,start,city,cityid);
                idate++;
        }


        function fetchIphoneXMLData(adult,start,city,cityid) {
            return new Promise(resolve=>{

                const end     = _SERVER.time(start).add(1, 'day').format('YYYY-MM-DD');
                const devid   = gerateDeviceID();
                const _url    = `https://iphone-xml.booking.com/json/bookings.getHotelAvailabilityMobile?detail_level=1&genius_freebies=2&show_distance_cc=1&request_less_fields=2&show_facilities_review_score=1&show_last_minute_saving=1&include_translations=2&add_bh_info=1&languagecode=de&urgency=1&include_taxes=1&include_count=1&location_source=autocomplete&show_price_trend=1&show_deals=flash%2Clastm%2Csmart%2Cgenius&children_qty=0&low_av_alternatives=0&&&order_by=popularity&show_if_class_is_estimated=1&show_categories=v3&show_location_score=1&show_last_reservation_text=1&show_reinforcement_text=v2&show_filtered_facilities=1&show_if_no_cc_allowed=2&show_soldout=1&show_is_personalized_result=0&show_flash_saving=1&max_persons=-2&use_direct_payment=1&add_ctrip_info=1&include_rack_rate_savings=1&&include_url=1&bh_alt_urgency_msg=1&show_refundable=1&check_price_is_final=1&show_extra_charges=1&room_qty=1&show_if_city_center=1&available_rooms=0&price_buckets=100&flash_deals_amount_if_unsigned=2&show_low_availability=2&show_business_badge=1&autoextend=1&affiliate_id=337862&user_os=6.0.1&user_version=11.3.1-android&network_type=wifi&bt=1&arrival_date=${start}&departure_date=${end}&city_ids=${cityid.replace('city=', '').replace('|si=ai%2Cco%2Cci%2Cre%2Cdi', '')}&rows=5000&device_id=${devid}da-ef8edab1ad7f&guest_qty=${adult}`;
                const options =  {
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                        'Authorization': 'Basic dGhlc2FpbnRzYnY6ZGdDVnlhcXZCeGdN'
                    },
                    url: _url,
                    timeout: 900000
                };

                _SERVER.request(options, function (err, resp, body) {
                    const allresult =  JSON.parse(body);
                    _HP.methods.Booking.parsemobile(allresult.result,adult,start,end,city,cityid).then(isok=>{

                        //go to next adult
                        if(isok==1||isok=='1'){
                            fetchIphoneXMLData(2,start,city,cityid);
                        }
                        //got to next date
                        //send result to server
                        if(isok==2||isok=='2'){

                            if(idate==countdate){
                                nextCityId()
                            }
                            if(idate<countdate){
                                //send job
                                _HP.methods.general.generateUrl(_HP.hotels.Booking,arg.job,arg.id,start)

                                //Go to Nekt Date
                                console.log("=> going to next date: "+idate);
                                nextDate(cityid)
                            }
                        }

                        //Got new IP Address
                        if(isok==0||isok=='0'){
                            //standart IP: 192.168.56.1
                            getNewIP(adult,start,city,cityid);

                        }
                    })
                })

            })
        }
        function getNewIP(adult,start,city,cityid) {
            console.log("OPS...........  IP got blocked");
            console.log('old ip:')
            console.log(currentip)
            try{
                const hosturl='http://192.168.56.1:88/newip?gateway='+slave+'&client='+client+'&job='+arg.id;
                _SERVER.fetch(hosturl).then(newIP=>{
                    console.log("new ip:")
                    setTimeout(()=>{
                        _SERVER.showExternalIP().then(ip=>{
                            if(!ip)
                                setTimeout(()=>{
                                    getNewIP(adult,start,city,cityid);
                                },60000)
                        });
                        fetchIphoneXMLData(adult,start,city,cityid)
                    },3000)
                })
            }
            catch(SyntaxError)
            {
                console.error(SyntaxError)
                console.error("Restarting..")
                isfetching = false; //prevent loop and wait
                setTimeout(()=>{
                    startMobileJob();
                },220000)

            }
        }
        });
    })

}
function gerateDeviceID()    {
   //
    let nr1 = Math.floor((Math.random() * 9999) + 1000);
    let nr2 = Math.floor((Math.random() * 9999) + 1000);
    let nr3 = Math.floor((Math.random() * 1) + 10);

    return `72331403-${nr1}-${nr2}-${nr3}`
}


setTimeout(()=>{

    if(hasmobile==-1)
        startSeleniumJOB();

    else
        startMobileJob()

},800);
